////////////////////////////////////////////////////////////////////////////////////////////////
// nwnx_MsgServer - various functions to use the Message server plugin and the connection part
// Original Scripter:  Septirage
//----------------------------------------------------------------------------------------------
// Last Modified By:   Septirage           2023-05-15
//----------------------------------------------------------------------------------------------
////////////////////////////////////////////////////////////////////////////////////////////////

/**************************** General Management ****************************/

//Active or Unactive the EnforcedSecurity 
// bActivated : TRUE / FALSE
//We recommand to keep it active, unless for debugin join issues.
void XPMsgServer_SetEnforcedSecurity(int bActivated);

//Get the state of the EnforcedSecurity
// TRUE : the enforced security is active. 
// FALSE otherwise
int XPMsgServer_GetEnforcedSecurity();

//Unblock the given player
//sPlayerName = "bioware account";
void XPMsgServer_Unblock(string sPlayerName);

//If you use a WelcomScreen, use it to sPlayerName as "knowed"
void XPMsgServer_Knowed(string sPlayerName);

/*****************************************************************************
***************** To be used in the AutoAuthenticationScript *****************
********* Note that these functions can only be used in this script **********
*****************************************************************************/

//Get the Name of the Player who active the script
string XPMsgServer_GetPlayerName();

//Get the IP address of the Player who active the script
int XPMsgServer_GetIP();

//Use it to choose the script response
//iType values :
//	0 => don't auto connect this player
//	1 => auto connect this player (no need to connection panel/ask)
//	-1 => kick out the player
void XPMsgServer_ScriptResponseStatus(int iType);

//Get the PublicCDKey of the player who active the script.
string XPMsgServer_GetCdKey();

// Return the current Privileges of the player who active the script.
// Work as bitmask with  4 for Admin, 2 for DM and 1 for PC.
// IE, to test if someone have all privileges, XPMsgServer_GetPrivilege() == 7
string XPMsgServer_GetPrivilege();


/*****************************************************************************
******************* To be used in the ConnectionValidScript ******************
********* Note that these functions can only be used in this script **********
*****************************************************************************/

//See DoYouRememberMeScript part
string XPMsgServer_GetPlayerName();

//See DoYouRememberMeScript part
int XPMsgServer_GetIP();

//Get the Log entered bythe Player who active the script
string XPMsgServer_GetLog();

//Get the Password entered bythe Player who active the script
string XPMsgServer_GetPwd();

//Get the script option
// "1" => Remember Me checked
// "0" => Remember Me unchecked
string XPMsgServer_GetOption();

//iType values :
//	0 => Invalid connection
//	1 => Connection ok, proceed
//	-1 => kick out the player
void XPMsgServer_ScriptResponseStatus(int iType);

//Use it to set the resonse text if invalid (for example : "Invalid password")
void XPMsgServer_ScriptResponseMsg(string sMsg);

//Get the PublicCDKey of the player who active the script.
string XPMsgServer_GetCdKey();

// Return the current Privileges of the player who active the script.
// Work as bitmask with  4 for Admin, 2 for DM and 1 for PC.
// IE, to test if someone have all privileges, XPMsgServer_GetPrivilege() == 7
string XPMsgServer_GetPrivilege();






/*****************************************************************************/

///////////////////////////////////////////////////////////////////////////////
////////////////////////////// IMPLEMENTATIONS ////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

/*****************************************************************************/


void XPMsgServer_SetEnforcedSecurity(int bActivated)
{
	NWNXSetInt("MsgServer", "EnforcedSecurity", "", 0, bActivated);
}

int XPMsgServer_GetEnforcedSecurity()
{
	return NWNXGetInt("MsgServer", "EnforcedSecurity", "", 0);
}

void XPMsgServer_ScriptResponseStatus(int iType)
{
	NWNXSetInt("MsgServer", "Validity", "", 0, iType);
}

void XPMsgServer_ScriptResponseMsg(string sMsg)
{
	NWNXSetString("MsgServer", "Response", "", 0, sMsg);
}

int XPMsgServer_GetIP()
{
	return NWNXGetInt("MsgServer", "CurIP", "", 0);
}

int XPMsgServer_GetPrivilege()
{
	return NWNXGetInt("MsgServer", "CurPriv", "", 0);
}

string XPMsgServer_GetPlayerName() 
{
	return NWNXGetString("MsgServer", "CurName", "", 0);	
}

string XPMsgServer_GetLog() 
{
	return NWNXGetString("MsgServer", "CurLog", "", 0);	
}

string XPMsgServer_GetPwd() 
{
	return NWNXGetString("MsgServer", "CurPwd", "", 0);	
}

string XPMsgServer_GetOption() 
{
	return NWNXGetString("MsgServer", "CurOption", "", 0);	
}

string XPMsgServer_GetCdKey() 
{
	return NWNXGetString("MsgServer", "CurCdKey", "", 0);	
}

void XPMsgServer_Unblock(string sPlayerName)
{
	NWNXSetInt("MsgServer", "Unblock", sPlayerName, 0, 0);
}

void XPMsgServer_Knowed(string sPlayerName)
{
	NWNXSetInt("MsgServer", "Knowed", sPlayerName, 0, 1);
}